STEP 1 STEP 1 STEP 1 STEP 1 STEP 1 STEP 1 STEP 1 STEP 1 STEP 1 STEP 1 STEP 1 STEP 1 

Move the folder "Derived life history traits across ectotherms" to your MATLAB work folder. This folder contains:

- BigMatrixNotShrink.m
- CalculatingElasticities.m
- CalculatingLifeHistoryTraits.m
- DEBIPMNotShrink_Macroorganism.m
- DEBIPMNotShrink_sens.m
- InputData.txt
- InputData.xlsx
- LifeHistory.m
- OffspringDist.m

Collect your DEB-IPM parameters as in InputData.xlsx with the following headings:
RecordID	Class	Order	Family	Species	Common_name	kappa	Lb	Lp	Lm	mu_juv	mu_adult	rB	Rm	E_Y

* Remember to add a value for E_Y for each entry.
* Make sure that each cell entry only has one word. E.g., change a species name 'Buteo buteo' to 'Buteo_buteo'.

Save these data as InputData.txt or use the existing dataset
NB: make sure you name the text file InputData!! Otherwise the code won't run.
Also note that the InputData file here is a subset of the full DEBBIES dataset, and serves as an example.


STEP 2 STEP 2 STEP 2 STEP 2 STEP 2 STEP 2 STEP 2 STEP 2 STEP 2 STEP 2 STEP 2 STEP 2

Calculate the following life history traits from the DEB-IPMs parameterised for all species: generation time, survivorship curve, age at sexual maturity, progressive growth, retrogressive growth, mean sexual reproduction, degree of iteroparity, net reproductive rate, mature life expectancy, population growth rate and demographic resilience (damping ratio).

To do this, run the commmands:

>> clear all
>> CalculatingLifeHistoryTraits

This script reads in InputData.txt (with all parameter values).
The output is LHtraits, which has all the above listed life history traits. Row numbers correspond to rows in InputData.txt.

The columns in LHtraits represent:
column 1: species ID
column 2: Feeding level
column 3: generation time
column 4: survivorship curve
column 5: age at maturity (L_alpha)
column 6: progressive growth
column 7: retrogressive growth
column 8: mean sexual reproduction (phi)
column 9: degree of iteroparity
column 10: net reproductive rate
column 11: mature life expectancy (L_omega)
column 12: population growth rate (lambda)
column 13: damping ratio (demographic resilience)

CalculatingLifeHistoryTraits.m calls on:
- DEBIPMNotShrink_Macroorganism.m, where all life history traits are calculated. DEBIPMNotShrink_Macroorganism.m calls on BigMatrixNotShrink.m, LifeHistory.m and OffspringDist.m.
- BigMatrixNotShrink.m has the four fundamental functions of the DEB-IPM.
- LifeHistory.m and OffspringDist.m are used to calculate lx and mx schedules.



STEP 3 STEP 3 STEP 3 STEP 3 STEP 3 STEP 3 STEP 3 STEP 3 STEP 3 STEP 3 STEP 3 STEP 3 STEP 3 

Calculate elasticities to identify which model parameter has the greatest influence on lambda (population growth rate).

To do this, run the commmands:

>> clear all
>> CalculatingElasticities

This script reads in InputData.txt (with all parameter values).
CalculatingElasticities first reads in the 8 parameters required to parameterise a DEB-IPM. It then calls DEBIPMNotShrink_sens.m to calculate which parameter is most influential to lambda (this function file calls BigMatrixShrink_MicroOrg where the DEB-IPM is calculated)

The parameters perturbed are in this order: Lb, Lp, Lm, Rm, rb, mu_adult, mu_juv

The output variable MostSensPar is an index value identifying which parameter is the most influential to the population growth rate. For example, if MostSensPar = 1, then Lb is the parameter that has the highest influence on lambda.
If MostSensPar = 7, then juvenile mortality rate has the highest influence on lambda.